/**
 * bootstrap-paginator.js v0.5
 * --
 * Copyright 2013 Yun Lai <lyonlai1984@gmail.com>
 * --
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
(function(f){var d=function(a,b){this.init(a,b)},e=null;d.prototype={init:function(b,c){this.$element=f(b);var h=(c&&c.bootstrapMajorVersion)?c.bootstrapMajorVersion:f.fn.bootstrapPaginator.defaults.bootstrapMajorVersion,a=this.$element.attr("id");if(h===2&&!this.$element.is("div")){throw"in Bootstrap version 2 the pagination must be a div element. Or if you are using Bootstrap pagination 3. Please specify it in bootstrapMajorVersion in the option"}else{if(h>2&&!this.$element.is("ul")){throw"in Bootstrap version 3 the pagination root item must be an ul element."}}this.currentPage=1;this.lastPage=1;this.setOptions(c);this.initialized=true},setOptions:function(a){this.options=f.extend({},(this.options||f.fn.bootstrapPaginator.defaults),a);this.totalPages=parseInt(this.options.totalPages,10);this.numberOfPages=parseInt(this.options.numberOfPages,10);if(a&&typeof(a.currentPage)!=="undefined"){this.setCurrentPage(a.currentPage)}this.listen();this.render();if(!this.initialized&&this.lastPage!==this.currentPage){this.$element.trigger("page-changed",[this.lastPage,this.currentPage])}},listen:function(){this.$element.off("page-clicked");this.$element.off("page-changed");if(typeof(this.options.onPageClicked)==="function"){this.$element.bind("page-clicked",this.options.onPageClicked)}if(typeof(this.options.onPageChanged)==="function"){this.$element.on("page-changed",this.options.onPageChanged)}this.$element.bind("page-clicked",this.onPageClicked)},destroy:function(){this.$element.off("page-clicked");this.$element.off("page-changed");this.$element.removeData("bootstrapPaginator");this.$element.empty()},show:function(a){this.setCurrentPage(a);this.render();if(this.lastPage!==this.currentPage){this.$element.trigger("page-changed",[this.lastPage,this.currentPage])}},showNext:function(){var a=this.getPages();if(a.next){this.show(a.next)}},showPrevious:function(){var a=this.getPages();if(a.prev){this.show(a.prev)}},showFirst:function(){var a=this.getPages();if(a.first){this.show(a.first)}},showLast:function(){var a=this.getPages();if(a.last){this.show(a.last)}},onPageItemClicked:function(b){var c=b.data.type,a=b.data.page;this.$element.trigger("page-clicked",[b,c,a])},onPageClicked:function(c,j,i,b){var a=f(c.currentTarget);switch(i){case"first":a.bootstrapPaginator("showFirst");break;case"prev":a.bootstrapPaginator("showPrevious");break;case"next":a.bootstrapPaginator("showNext");break;case"last":a.bootstrapPaginator("showLast");break;case"page":a.bootstrapPaginator("show",b);break}},render:function(){var b=this.getValueFromOption(this.options.containerClass,this.$element),a=this.options.size||"normal",p=this.options.alignment||"left",w=this.getPages(),r=this.options.bootstrapMajorVersion===2?f("<ul></ul>"):this.$element,i=this.options.bootstrapMajorVersion===2?this.getValueFromOption(this.options.listContainerClass,r):null,s=null,v=null,t=null,c=null,x=null,u=0;switch(a.toLowerCase()){case"large":case"small":case"mini":this.$element.addClass(f.fn.bootstrapPaginator.sizeArray[this.options.bootstrapMajorVersion][a.toLowerCase()]);break;default:break}if(this.options.bootstrapMajorVersion===2){switch(p.toLowerCase()){case"center":this.$element.addClass("pagination-centered");break;case"right":this.$element.addClass("pagination-right");break;default:break}}this.$element.addClass(b);this.$element.empty();if(this.options.bootstrapMajorVersion===2){this.$element.append(r);r.addClass(i)}this.pageRef=[];if(w.first){s=this.buildPageItem("first",w.first);if(s){r.append(s)}}if(w.prev){v=this.buildPageItem("prev",w.prev);if(v){r.append(v)}}for(u=0;u<w.length;u=u+1){x=this.buildPageItem("page",w[u]);if(x){r.append(x)}}if(w.next){t=this.buildPageItem("next",w.next);if(t){r.append(t)}}if(w.last){c=this.buildPageItem("last",w.last);if(c){r.append(c)}}},buildPageItem:function(m,o){var c=f("<li></li>"),q=f("<a></a>"),a="",b="",r=this.options.itemContainerClass(m,o,this.currentPage),p=this.getValueFromOption(this.options.itemContentClass,m,o,this.currentPage),n=null;switch(m){case"first":if(!this.getValueFromOption(this.options.shouldShowPage,m,o,this.currentPage)){return}a=this.options.itemTexts(m,o,this.currentPage);b=this.options.tooltipTitles(m,o,this.currentPage);break;case"last":if(!this.getValueFromOption(this.options.shouldShowPage,m,o,this.currentPage)){return}a=this.options.itemTexts(m,o,this.currentPage);b=this.options.tooltipTitles(m,o,this.currentPage);break;case"prev":if(!this.getValueFromOption(this.options.shouldShowPage,m,o,this.currentPage)){return}a=this.options.itemTexts(m,o,this.currentPage);b=this.options.tooltipTitles(m,o,this.currentPage);break;case"next":if(!this.getValueFromOption(this.options.shouldShowPage,m,o,this.currentPage)){return}a=this.options.itemTexts(m,o,this.currentPage);b=this.options.tooltipTitles(m,o,this.currentPage);break;case"page":if(!this.getValueFromOption(this.options.shouldShowPage,m,o,this.currentPage)){return}a=this.options.itemTexts(m,o,this.currentPage);b=this.options.tooltipTitles(m,o,this.currentPage);break}c.addClass(r).append(q);q.addClass(p).html(a).on("click",null,{type:m,page:o},f.proxy(this.onPageItemClicked,this));if(this.options.pageUrl){q.attr("href",this.getValueFromOption(this.options.pageUrl,m,o,this.currentPage))}if(this.options.useBootstrapTooltip){n=f.extend({},this.options.bootstrapTooltipOptions,{title:b});q.tooltip(n)}else{q.attr("title",b)}return c},setCurrentPage:function(a){if(a>this.totalPages||a<1){throw"Page out of range"}this.lastPage=this.currentPage;this.currentPage=parseInt(a,10)},getPages:function(){var b=this.totalPages,a=(this.currentPage%this.numberOfPages===0)?(parseInt(this.currentPage/this.numberOfPages,10)-1)*this.numberOfPages+1:parseInt(this.currentPage/this.numberOfPages,10)*this.numberOfPages+1,i=[],c=0,j=0;a=a<1?1:a;for(c=a,j=0;j<this.numberOfPages&&c<=b;c=c+1,j=j+1){i.push(c)}i.first=1;if(this.currentPage>1){i.prev=this.currentPage-1}else{i.prev=1}if(this.currentPage<b){i.next=this.currentPage+1}else{i.next=b}i.last=b;i.current=this.currentPage;i.total=b;i.numberOfPages=this.options.numberOfPages;return i},getValueFromOption:function(a){var c=null,b=Array.prototype.slice.call(arguments,1);if(typeof a==="function"){c=a.apply(this,b)}else{c=a}return c}};e=f.fn.bootstrapPaginator;f.fn.bootstrapPaginator=function(a){var b=arguments,c=null;f(this).each(function(o,n){var l=f(n),m=l.data("bootstrapPaginator"),p=(typeof a!=="object")?null:a;if(!m){m=new d(this,p);l=f(m.$element);l.data("bootstrapPaginator",m);return}if(typeof a==="string"){if(m[a]){c=m[a].apply(m,Array.prototype.slice.call(b,1))}else{throw"Method "+a+" does not exist"}}else{c=m.setOptions(a)}});return c};f.fn.bootstrapPaginator.sizeArray={"2":{large:"pagination-large",small:"pagination-small",mini:"pagination-mini"},"3":{large:"pagination-lg",small:"pagination-sm",mini:""}};f.fn.bootstrapPaginator.defaults={containerClass:"",size:"normal",alignment:"left",bootstrapMajorVersion:2,listContainerClass:"",itemContainerClass:function(c,b,a){return(b===a)?"active":""},itemContentClass:function(c,b,a){return""},currentPage:1,numberOfPages:5,totalPages:1,pageUrl:function(c,b,a){return null},onPageClicked:null,onPageChanged:null,useBootstrapTooltip:false,shouldShowPage:function(c,b,a){var h=true;switch(c){case"first":h=(a!==1);break;case"prev":h=(a!==1);break;case"next":h=(a!==this.totalPages);break;case"last":h=(a!==this.totalPages);break;case"page":h=true;break}return h},itemTexts:function(c,b,a){switch(c){case"first":return PT_CV_PAGINATION.first;case"prev":return PT_CV_PAGINATION.prev;case"next":return PT_CV_PAGINATION.next;case"last":return PT_CV_PAGINATION.last;case"page":return b}},tooltipTitles:function(c,b,a){switch(c){case"first":return PT_CV_PAGINATION.goto_first;case"prev":return PT_CV_PAGINATION.goto_prev;case"next":return PT_CV_PAGINATION.goto_next;case"last":return PT_CV_PAGINATION.goto_last;case"page":return(b===a)?PT_CV_PAGINATION.current_page+" "+b:PT_CV_PAGINATION.goto_page+" "+b}},bootstrapTooltipOptions:{animation:true,html:true,placement:"top",selector:false,title:"",container:false}};f.fn.bootstrapPaginator.Constructor=d}(window.jQuery));